<?php
   /*
   * 			backup_website.php V1.1 29-03-12 by Spooks
   *
   *  		Upload all folders and files of your site in ZIP or GZIP format.
   */

   $exclude = 'DIR_FS_BACKUP, DIR_FS_CACHE, SESSION_WRITE_DIRECTORY'; // add excluded as required, include full path from catalog folder i.e. includes/languages/
   ini_set('memory_limit', '1024M'); // set memory limit, increase if you receive an out of memory error, you may need to speak to your host!!
   $guess = 0; // increase if size estimation is too low
   error_reporting(0); // comment out if you have any problems
   $no_session = false; // set to true if you don't use sessions for admin login. WARNING doing this creates a security risk.
	$session_name = 'admin'; // Alter if you've changed the admin session name (NOT just renamed the admin folder) 

   $action = isset($_GET['action']) ? $_GET['action'] : '';
   $mode = isset($_POST['mode']) ? $_POST['mode'] : '';
   if ($action == 'savenow' && ($mode == 'file' || $mode == 'memory' || $mode == 'gzip'))
   {
      require ('includes/configure.php');
      chdir(DIR_FS_ADMIN);
      require(DIR_WS_FUNCTIONS . 'database.php');
      tep_db_connect() or die('Unable to connect to database server!');
      require(DIR_WS_FUNCTIONS . 'general.php');
      require_once(DIR_WS_FUNCTIONS . 'backup_site_functions.php');
      require(DIR_WS_FUNCTIONS . 'html_output.php');
      require(DIR_WS_INCLUDES . 'database_tables.php');
      $configuration_query = tep_db_query('select configuration_key as cfgKey, configuration_value as cfgValue from ' . TABLE_CONFIGURATION);
      while ($configuration = tep_db_fetch_array($configuration_query)) define($configuration['cfgKey'], $configuration['cfgValue']);
      include(DIR_WS_CLASSES . 'language.php');
      $lng = new language();
      if (isset($_GET['language']) && tep_not_null($_GET['language'])) $lng->set_language($_GET['language']);
      $language = $lng->language['directory'];
      require(DIR_WS_FUNCTIONS . 'sessions.php');
      require(DIR_WS_LANGUAGES . $language . '.php');
      include(DIR_WS_LANGUAGES . $language . '/backup_website.php');
      tep_session_name('osCAdminID');
      tep_session_save_path(SESSION_WRITE_DIRECTORY);
      if (function_exists('session_set_cookie_params')) 
      {
         session_set_cookie_params(0, DIR_WS_ADMIN);
      } 
      elseif (function_exists('ini_set')) 
      {
         ini_set('session.cookie_lifetime', '0');
         ini_set('session.cookie_path', DIR_WS_ADMIN);
      }
      tep_session_start();

      if (!tep_session_is_registered($session_name) && !$no_session) header('Location: ' . 'index.php');
      tep_set_time_limit(0);

      if (function_exists('apache_setenv')) apache_setenv('no-gzip', '1');
      $rootdir = '/' . trim(DIR_FS_DOCUMENT_ROOT,' /') . '/';
      $list = explode(',', $exclude);
      $exclude = array();
      foreach ($list as $remove) $exclude[] = defined(trim($remove)) ? constant(trim($remove)) : $rootdir . trim($remove , ' /') . '/';
      $filename = str_replace(" ", "-", STORE_NAME). '-Website-Backup';
      $filedate = '-' . str_replace("/", "-",date(DATE_FORMAT));	
      $files = file_list($rootdir);
      $size = dir_size($rootdir);
      if ($mode == 'file')
      {
         $wok = true;
         $zip = new ZipArchive();
         $filedate .= '.zip';
         @array_map( "unlink", glob( DIR_FS_BACKUP . $filename."*" ) );
         $zip->open(DIR_FS_BACKUP . $filename . $filedate, ZipArchive::CREATE);
         $zip->addEmptyDir($filename);
         foreach ($files as $file)
         {
            reset($exclude);
            foreach ($exclude as $remove) if (strpos($file,$remove) === 0 ) continue 2;
            $name = str_replace($rootdir, $filename . '/', $file);
            if (@is_file($file))
            {
            	if (@filesize($file) == 0 ) 
            	{
            		$fname = basename($file);
            		$zip->addFromString(str_ireplace($fname, '', $name) . $fname,'');
            	}
            	else 
            	{	
             		if ($zip->addFile($file, $name) === false) $wok = false;
             	}	
            } 	
            if (@is_dir($file) && is_empty($file)) $zip->addFromString($name. '/.htaccess','');
            elseif (@is_dir($file)) if ($zip->addEmptyDir($file) === false) $wok = false;
            if (!$wok) break;
         }
         $zip->addFromString('Backup info.txt', STORE_NAME . sprintf(BACKUP_INFO, date(PHP_DATE_TIME_FORMAT) . "\n\n",
         $size[2], $size[1]) . showsize(memory_get_peak_usage(true)) . "\n\n" . MESSAGE);
         if ($zip->close() === false) $wok = false;
         if ($wok && $fp = @fopen(DIR_FS_BACKUP . $filename . $filedate, 'rb'))
         {
            $buffer = fread($fp, filesize(DIR_FS_BACKUP . $filename . $filedate));
            fclose($fp);
            header("Pragma: public");
            header("Expires: 0");
            header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
            header("Cache-Control: public");
            header("Content-Description: File Transfer");
            header("Content-type: application/octet-stream");
            header("Content-Disposition: attachment; filename=\"".$filename . $filedate."\"");
            header("Content-Transfer-Encoding: binary");
            header("Accept-Encoding: 0");
            header("Content-Length: ".strlen($buffer));
            echo $buffer;
            @unlink(DIR_FS_BACKUP . $filename . $filedate);
            exit;
         }
         else
         {
            @unlink(DIR_FS_BACKUP . $filename . $filedate);
            showerror(ERROR_WRITING);
         }
      }
      elseif ($mode == 'memory')
      {
         require_once(DIR_WS_CLASSES . 'zipstream.php');
         $filedate .= '.zip';
         $zip = new ZipStream($filename . $filedate, array('comment' => STORE_NAME . 'Website Backup on ' .
         date(PHP_DATE_TIME_FORMAT), 'large_file_size' => (20 * 1024 * 1024), 'large_file_method' => 'store') );
         $zip->size = floor($size[0] * (0.8 + ($guess/100)));
         foreach ($files as $file)
         {
            reset($exclude);
            foreach ($exclude as $remove) if (strpos($file,$remove) === 0 ) continue 2;
            $data = file_get_contents($file);
            $file_opt = array('time' => filemtime($file),'comment' => '');
            $name = str_replace($rootdir, $filename . '/', $file);
            if (@is_dir($file) && is_empty($file)) $zip->add_file($name. '/.htaccess','', $file_opt);
            else $zip->add_file($name, $data, $file_opt);
         }
         $file_opt = array('time' => time(),'comment' => '');
         $zip->add_file('Backup info.txt', STORE_NAME . sprintf(BACKUP_INFO, date(PHP_DATE_TIME_FORMAT) . "\n\n",  $size[2], $size[1]) .
         showsize(memory_get_peak_usage(true)) . "\n\n" . MESSAGE, $file_opt);
         $zip->finish();
         exit;
      }
      elseif ($mode == 'gzip')
      {
			$wok = true;
         require_once(DIR_WS_CLASSES . 'tar.class.php');
         $filedate .= '.tar.gz';
         $tar = new tar;
         $tar->folder = 'Backup/';
         $tar->remove = $rootdir;
         foreach ($files as $file)
         {
            reset($exclude);
            foreach ($exclude as $remove) if (strpos($file,$remove) === 0 ) continue 2;
            if (@is_dir($file)) 
            {
            	if ($tar->addDirectory($file, true) === false) $wok = false;
            }	
            else 
            {
            	if ($tar->addFile($file, true) === false) $wok = false;
            }	
         }
         $tar->addString('Backup info.txt', STORE_NAME . sprintf(BACKUP_INFO, date(PHP_DATE_TIME_FORMAT) . "\n\n",  $size[2], $size[1]) . showsize(memory_get_peak_usage(true)) . "\n\n" . MESSAGE);
			if ($wok)
			{
				 $tar->toTar($filename . $filedate,true,true);				 
				 exit;
			}	 
         else 
         {
         	showerror(ERROR_GZIP);
         }	
      }
   }
   else
   {
      require('includes/application_top.php');
      require_once(DIR_WS_FUNCTIONS . 'backup_site_functions.php');
      if (!tep_session_is_registered($session_name) && !$no_session) header('Location: ' . 'index.php');
      $rootdir = '/' . trim(DIR_FS_DOCUMENT_ROOT,' /') . '/';
   }
   if (!is_array($exclude))
   {
   	$list = explode(',', $exclude);
   	$exclude = array();
   	foreach ($list as $remove) $exclude[] = defined(trim($remove)) ? constant(trim($remove)) : $rootdir . trim($remove , ' /') . '/';
   }	
   require(DIR_WS_INCLUDES . 'template_top.php');
?>

<!-- body //-->
<table border="0" width="100%" cellspacing="2" cellpadding="2">
  <tr>

<!-- body_text //-->
<?php

 ?>
    <td width="100%" valign="top"><table border="0" width="100%" cellspacing="5" cellpadding="5">
      <tr>
        <td class="pageHeading"><br /><br /><?php echo HEADING_TITLE; ?></td>
          </tr>
      <tr>
        <td>
<?php
   $size = dir_size($rootdir);
   printf(WEBSITE_SIZE, showsize($size[0]), showsize(floor($size[0]*(0.68 + ($guess/100)))), $size[2], $size[1]);
?>
			</td>
      </tr>
      <tr>
<td class="main"><?php
        		echo  EXCLUDED . str_ireplace($rootdir, '',implode(' + ', $exclude));
        		$missing = array();
        		foreach ($exclude as $dir) if (!is_dir($dir)) $missing[] = $dir; 
        		if (count($missing))
        		{
        				echo '<br /><br /><table cellpadding="0" cellspacing="0" border="0" align="left"><tr><td valign="top">'.MISSING_FOLDER.'&nbsp;&nbsp;&nbsp;</td><td><font color="red">';
        				foreach ($missing as $dir) echo $dir .'<br />';    
        				echo '</font></td></tr></table>';				
        		}	
        		?></td>
          </tr>
      <tr>
        <td><?php echo tep_draw_separator('pixel_trans.gif', '100%', '10'); ?></td>
      </tr>
        <tr>
         <td class="main">
         <div style="border: 1px solid; width:50%; padding:10px 20px 20px; text-align: left;">
			<?php echo MODE_1; ?><div style="text-align:center; width:100%;">
<?php
   if (is_writeable(DIR_FS_BACKUP))
   {
         if (version_compare(PHP_VERSION, '5.2.0', '>=') && class_exists('ZipArchive'))
         {
            echo tep_draw_form('save_files', FILENAME_STORE_BACKUP, 'action=savenow', 'post') . tep_draw_hidden_field('mode', 'file') .
            '<br /><br />' . MESSAGE_1. '<input title="Save" name="" type="submit" value="' . MESSAGE_2 . '" />' . MESSAGE_3 . MESSAGE_6 . '</form>';
         }
         else
         {
            echo '<br />' . (version_compare(PHP_VERSION, '5.2.0', '>=') ? ERROR_CLASS_MISSING : sprintf(WARNING_VERSION, PHP_VERSION) . '5.2.0');
         }

   }
   else
   {
      echo ERROR_BACKUP_DIRECTORY_NOT_WRITEABLE . '<br /><br />' . DIR_FS_BACKUP;
   }
?>
        </div> </div>
        <br />
        <div style="border: 1px solid; width:50%; padding:10px 20px 20px; text-align: left;">
<?php
	echo MODE_2 . '<div style="text-align:center; width:100%;">';
   if (version_compare(PHP_VERSION, '5.1.2', '>=') )
   {

				
 		echo tep_draw_form('save_files', FILENAME_STORE_BACKUP, 'action=savenow', 'post') . tep_draw_hidden_field('mode', 'memory') .
      '<br /><br />' . MESSAGE_1. '<input title="Save" name="" type="submit" value="' . MESSAGE_2 . '" />' . MESSAGE_4 . MESSAGE_6 . '</form>'; 
   }
   else
   {
      echo  '<br />' . sprintf(WARNING_VERSION, PHP_VERSION) . '5.1.2<br /><br />' ;
   }
?>
			</div> </div>			
			<br />
			<div style="border: 1px solid; width:50%; padding:10px 20px 20px; text-align: left;">
			<?php echo MODE_3; ?><div style="text-align:center; width:100%;">
<?php
      echo tep_draw_form('save_files', FILENAME_STORE_BACKUP, 'action=savenow', 'post') . tep_draw_hidden_field('mode', 'gzip') .
      '<br /><br />' . MESSAGE_1. '<input title="Save" name="" type="submit" value="' . MESSAGE_2 . '" />' . MESSAGE_5 . MESSAGE_6 . '</form>';
      echo '<br /><br />This method is experimental, if you use please report results and:<br />PHP Version: <strong>'. PHP_VERSION . '</strong>  Method: <strong>' . (class_exists('Phar') && ini_get('phar.readonly') != 1 ? 'Phar' : 'Tar') . '</strong>  Server OS: <strong>' . php_uname("s") . '</strong>';
?>
        </div> </div>
		<br />
        </td>
      </tr>
      <tr>
        <td class="main" style="text-indent:60px"><?php echo INFO; ?></td>
      </tr>
    </table></td>
<!-- body_text_eof //-->
  </tr>
</table>
<!-- body_eof //-->

<!-- footer //-->
<?php require(DIR_WS_INCLUDES . 'footer.php'); ?>
<!-- footer_eof //-->
<br>
</body>
</html>
<?php require(DIR_WS_INCLUDES . 'application_bottom.php'); 
?>