<?php
   /*
   * 			backup_site_functions.php V1 29-03-12 by Spooks
   *
   *  		Upload all folders and files of your site in ZIP format.
   */
   function dir_size($dir_name)
   {
      global $exclude;
      $dir_size = array(0 => 0, 1 => 0, 2 => 0);
      $dir_name = str_replace("//", "/", $dir_name);
      if (is_dir($dir_name) && !is_link($dir_name))
      {
         if ($dh = opendir($dir_name))
         {
            while (($file = readdir($dh)) !== false)
            {
               if ($file !='.' && $file != '..')
               {
                  if (is_file($dir_name.'/'.$file))
                  {
                     $dir_size[1]++;
                     $dir_size[0] += ceil(filesize($dir_name.'/'.$file));
                  }
                  if(is_dir($dir_name.'/'.$file))
                  {
                     reset($exclude);
                     foreach ($exclude as $remove) if (strpos($dir_name.'/'.$file.'/', $remove) === 0 ) continue 2;
                     $dir_size[2]++;
                     $temp =  dir_size($dir_name.'/'.$file);
                     while (list($key,) = each($temp)) $dir_size[$key] += $temp[$key];
                  }
               }
            }
         }
         closedir($dh);
      }
      return $dir_size;
   }

   function file_list($directory)
   {    
      $contents = array();
      if ($handle = opendir($directory)) {
         while (false !== ($file = readdir($handle))) {
            if ($file != "." && $file != "..") {
               if (is_dir($directory. "/" . $file)) {
                  $contents = array_merge($contents, file_list($directory. "/" . $file));
                  $file = $directory . "/" . $file;
                  $contents[] = preg_replace("/\/\//si", "/", $file);
               } elseif (is_file($directory. "/" . $file)) {
                  $file = $directory . "/" . $file;
                  $contents[] = preg_replace("/\/\//si", "/", $file);
               }
            }
         }
         closedir($handle);
      }
      return $contents;
   }

   function is_empty($path)
   {
      $dir = dir($path);
      $not_empty = false;
      while ((false !== ($item = $dir->read())) && (!$not_empty)) if ($item != '.' && $item != '..') $not_empty = true;
      $dir->close();
      return !$not_empty;
   }

   function showsize($bytes)
   {
      $sz = ' KMGTP';
      $factor = floor((strlen($bytes) - 1) / 3);
      return round($bytes / pow(1024, $factor ), ($factor > 1 ? 2 : 0) ) . ' ' . ($factor ? @$sz[$factor] . 'B' : 'Bytes');
   }
   
   function showerror($message)
   {
   	$messageStack = is_array($_SESSION['messageToStack']) ? $_SESSION['messageToStack'] : array();
      $messageStack[] = array('text' => $message, 'type' => 'error');
      $_SESSION['messageToStack'] = $messageStack;
      tep_redirect(tep_href_link('backup_website.php'));
   }      
?>